function ltoggle(el) {
	Element.toggle(el)
	return false;
}
function LoadSettings(){
	//load input field settings
	if( readCookie('PandoraGrabber_UserName') )
		$('pandoraUserName').value = readCookie('PandoraGrabber_UserName');
	if( readCookie('PandoraGrabber_LastFMUserName') )
		$('lastFmUserName').value = readCookie('PandoraGrabber_LastFMUserName');
	if( readCookie('PandoraGrabber_LastFMPassword') )
		$('lastFmPassword').value = readCookie('PandoraGrabber_LastFMPassword');
	if( readCookie('PandoraGrabber_songsBeforeReload') )
		$('songsBeforeReload').value = readCookie('PandoraGrabber_songsBeforeReload');

	//load dropdown lists settings
    if( readCookie('PandoraGrabber_AddToItunes') )
		$('addToItunes').selectedIndex = readCookie('PandoraGrabber_AddToItunes');    
    if( readCookie('PandoraGrabber_CruiseControl') )
		$('cruiseControl').selectedIndex = readCookie('PandoraGrabber_CruiseControl');
	if( readCookie('PandoraGrabber_LastFMData') )
		$('lastFmData').selectedIndex = readCookie('PandoraGrabber_LastFMData');
	if( readCookie('PandoraGrabber_CddbLookup') )
		$('cddb').selectedIndex = readCookie('PandoraGrabber_CddbLookup');
	
	//load checkbox settings	
	if( readCookie('PandoraGrabber_hideSettings') )
		$('hideSettings').checked = (readCookie('PandoraGrabber_hideSettings')=='true');
	if( readCookie('PandoraGrabber_hideInfo') )
		$('hideInfo').checked = (readCookie('PandoraGrabber_hideInfo')=='true');
		
	// Environment Changes
	if($F('hideSettings')) Element.hide('settingsPanel');
	if($F('hideInfo')) Element.hide('infoPanel');
}

function resetStatus() {
    artistName = $F('artist');
    songName = $F('song');
    if (isLastFmDataOn()) {
		if(artistName=='' && songName=='') {
			Element.update('bandBio2',"Waiting on Artist info.");
			Element.update("songStats","Waiting on Song info.");
			Element.update('topFans',"Waiting on Fan Info.");
		} else {
			Element.update('bandBio2',"Initing band bio.");
			Element.update("songStats","Initing song stats.");
			Element.update('topFans',"Initing top fans fetch.");
		}
    }
    else {
        Element.update('bandBio2',"Band bio disabled.");
        Element.update("songStats","Song stats disabled.");
        Element.update('topFans',"Top fans fetch disabled.");
    }
    if (isCruise()) {
		if(artistName=='' && songName=='') 
        	Element.update('resultTarget2',"Waiting on Artist and Song info.");
		else
        	Element.update('resultTarget2',"Initing MP3 rip.");
    }
    else {
        Element.update('resultTarget2',"MP3 ripping set to manual - Click the [Grab It] button to rip selected tracks.");
    }

    if (isAddTrackEnabled() && isCruise()) {
		if(artistName=='' && songName=='') 
        	Element.update('addTrackLastFm',"Waiting on Artist and Song info.");
		else
        	Element.update('addTrackLastFm',"Initing add track to last.fm");
    }
    else if (!isCruise() && isAddTrackEnabled()) {
        Element.update('addTrackLastFm',"Click the [Grab It] button to add this track - Select cruise control [on] for adding all played tracks.");
    }
    else {
        Element.update('addTrackLastFm',"To enable last.fm listened track management - Type in your last.fm user name and password. If authentication is provided the song will be added every time an MP3 is ripped. To manually manage tracks do not use the cruise control option.");
    }
}

function grabMp3() {
    artistName = $F('artist');
    songName = $F('song');
	if(artistName=='' && songName=='') {
		alert("Not Quite Ready");
		return;
	}
    if (isAddTrackEnabled()) {
        Element.update('addTrackLastFm',"Initing add track to last.fm.");
    }
    else {
        Element.update('addTrackLastFm',"You enabled last.fm listened track managment - Type in your last.fm user name and password. If authentication is provided the song will be added every time an MP3 is ripped. To manually manage tracks do not use the cruise control option.");
    }
    Element.update('resultTarget2',"Initing MP3 rip.");
    downloadMP3();
}

function downloadMP3() {
    lookup = $F("cddb");
    artistName = $F("artist");
    songName = $F("song");
    albumImgLoc = $F("albumImgLocation");
    pandoraUserNameValue = $F("pandoraUserName");
    stationIdValue = $F("stationId");
    cruise = $F('cruiseControl');
    itunesEnabled = $F('addToItunes');
    if(artistName == '' && songName=='') {
	    Element.update('resultTarget2',"unable to locate artist and song information.");
	} else
    	Element.update('resultTarget2',"Fetching ID3 information and tagging MP3 for artist. (" + decodeURIComponent(artistName) + ") song (" + decodeURIComponent(songName) + ")....");
    var url = "process";
    var pars = "action=grab&artist=" + artistName + "&title=" + songName + "&album=&genre=&comment=ripped by [PaNDoRas jAR] your source for listening pleasure&year=&cruise=" + cruise + "&albumImgLocaction=" + albumImgLoc + "&pandoraUserName=" + pandoraUserNameValue + "&stationId=" + stationIdValue + "&cddbLookUp=" + lookup + "&addToItunes=" + itunesEnabled;
    var myAjax = new Ajax.Request(url,
    {
        method: 'get',
        parameters: pars,
        onComplete: downloadMP3Response
    });
}

function isAddTrackEnabled() {
    lastFmUserNameValue = $F('lastFmUserName');
    lastFmPasswordValue = $F('lastFmPassword');
    return (lastFmUserNameValue.length != 0 && lastFmPasswordValue.length != 0);
}

function addTrack() {

    if (!isAddTrackEnabled()) {
        return;
    }

    lastFmUserNameValue = $F('lastFmUserName');
    lastFmPasswordValue = $F('lastFmPassword');

    Element.update('addTrackLastFm',"Adding track to last.fm");

    var url = "process";
    var pars = "action=addTrack&lastFmUserName=" + lastFmUserNameValue + "&lastFmPassword=" + lastFmPasswordValue

    var myAjax = new Ajax.Request(url,
    {
        method: 'get',
        parameters: pars,
        onComplete: showAddTrack
    });
}

function getSongStats() {
    artistName = $F('artist');
    songName = $F('song');
    Element.update("songStats","Retrieving last.fm stats");
    var url = "process";
    var pars = "action=getStats&artist=" + artistName + "&title=" + songName;

    var myAjax = new Ajax.Request(url,
    {
        method: 'get',
        parameters: pars,
        onComplete: showSongStats
    });
}

function getTopFans() {
    Element.update('topFans',"Retrieving top fans.");
    artistName = $F('artist');
    songName = $F('song');
    var url = "process";
    var pars = "action=getTopFans&artist=" + artistName + "&title=" + songName;

    var myAjax = new Ajax.Request(url,
    {
        method: 'get',
        parameters: pars,
        onComplete: showTopFans
    });
}

function getArtistBio() {
    artistName = $F('artist');
    songName = $F('song');
    Element.update('bandBio2',"Retrieving artist (" + decodeURIComponent(artistName) + ") bio....");
    var url = "process";
    var pars = "action=getBio&artist=" + artistName;

    var myAjax = new Ajax.Request(url,
    {
        method: 'get',
        parameters: pars,
        onComplete: showArtistBioResponse
    });
}

function showArtistBioResponse(originalRequest) {
    Element.update('bandBio2',originalRequest.responseText);
    getSongStats();
}

function downloadMP3Response(originalRequest) {
	newtext = originalRequest.responseText;
	nt = newtext.split(/<br.*?>/);
	respan = /<\/?span.*?>/gi;
	if(nt.length>0) 
		newtext = nt[0].replace(respan,'') + 
				  "<br>" +
				  nt[1].replace(respan,'');
    Element.update('resultTarget2',newtext);
    if (isAddTrackEnabled()) {
        addTrack();
    }
}

function showSongStats(originalRequest) {
    s = originalRequest.responseText;
    searchString = 'albumImgLocation" type="hidden" value="';
    start = s.indexOf(searchString);
    if (start != -1) {
        end = s.indexOf('"/>', start)
        v = s.substring(start + searchString.length, end);
        $('albumImgLocation').value = v;
    }
    else {
        $('albumImgLocation').value = "";
    }
    Element.update("songStats", s);
    getTopFans();
}

function isCruise() {
	cruise = $F('cruiseControl');
    return (cruise == "on");
}

function isLastFmDataOn() {
	cruise = $F('lastFmData');
    return (cruise == "on");
}

function showTopFans(originalRequest) {
    Element.update('topFans',originalRequest.responseText);
    if (isCruise()) {
        InitializeTimer(20, "grabMp3()");
    }
}

function showAddTrack(originalRequest) {
    Element.update('addTrackLastFm',originalRequest.responseText);
}

function SaveSettings(){
	//input fields
	createCookie('PandoraGrabber_UserName', $F('pandoraUserName'));
	createCookie('PandoraGrabber_LastFMUserName', $F('lastFmUserName'));
	createCookie('PandoraGrabber_LastFMPassword', $F('lastFmPassword'));
	createCookie('PandoraGrabber_songsBeforeReload', $F('songsBeforeReload'));

	//dropdown lists	
	createCookie('PandoraGrabber_CruiseControl', $('cruiseControl').selectedIndex);
	createCookie('PandoraGrabber_LastFMData', $('lastFmData').selectedIndex);
	createCookie('PandoraGrabber_CddbLookup', $('cddb').selectedIndex);
    createCookie('PandoraGrabber_AddToItunes', $('addToItunes').selectedIndex);

    //Checkboxes
	createCookie('PandoraGrabber_hideSettings', $('hideSettings').checked);
	createCookie('PandoraGrabber_hideInfo', $('hideInfo').checked);
	

	alert("Settings Successfully Saved!");
	resetStatus();
}

function createCookie(name, value){
	var days = 60;	//days before cookie expires
	var date = new Date();

	date.setTime(date.getTime()+(days*24*60*60*1000));
	var expires = "; expires=" + date.toGMTString();

	document.cookie = name + "=" + value + expires + "; path=/";
}

function readCookie(name){
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++)
	{
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}