package server;

import java.util.Map;
import java.util.HashMap;

public class Request {
    Map<String,String> parameters = new HashMap<String, String>();
    String requestId;

    public Request(String requestId) {
        this.requestId = requestId;
    }

    public Map<String,String> getParameters() {
        return parameters;
    }

    public String getRequestId() {
        return requestId;
    }

    public void addParameter(String paramName, String paramValue) {
        parameters.put(paramName, paramValue);
    }

    public String getParamter(String paramName) {
        return parameters.get(paramName);
    }

    public Session getSession() {
        SessionManager instance = SessionManager.getInstance();
        return instance.getSession(this);
    }

}
