var playCount = 0;
var secs = 20;
var functionName;
var timerID = null;
var timerRunning = false;
var delay = 1000;
window.RHINO = false;
var originalTitle = document.title;
var pausedClicked = false;
var gDisplayFavoriteLink = false;


function stationChange(stationID) {
    alert(stationID);
    stopTheClock();
    pausedClicked = false;
    gCurrentStation = stationID;
    $('stationId').value = stationID;
}

function pandoraSongPlayed(song, artist) {

    if (pausedClicked) {
        pausedClicked = false;
    }
    else {
        stopTheClock();
		
        if ($F("songsBeforeReload")>0 && playCount >= $F("songsBeforeReload")) {
            window.location.reload();
        }

        var escapesong = encodeURIComponent(song);
        var escapeartist = encodeURIComponent(artist);

        $('artist').value = escapeartist;
        $('song').value = escapesong;

        document.title = song + "  by  " + artist + " - " + "Pandora's Jar";

        resetStatus();
        if (isLastFmDataOn()) {
            InitializeTimer(15, "getArtistBio()");
        }
        else {
            if (isCruise()) {
                InitializeTimer(15, "grabMp3()");
            }
        }
        playCount++;
    }
}

function pandoraSongPaused() {
    pausedClicked = true;
    document.title = "(Paused) " + args[0] + "  by  " + args[1] + " - " + "PandoraFM";
}


function pandoraEventsError(errormsg) {
    //alert("pandoraEventsError");
}


function pandoraSongEnded(song, artist) {
    pausedClicked = false;
}

function onTunerEvent() {
    if (!arguments || arguments.length == 0) {
        return;
    }

    var event = arguments[0];
    var eventArgs = [];
    for (var i = 1; i < arguments.length; i++) {
        eventArgs[i - 1] = unescape(arguments[i]);
    }
	
    if (window[event] != null) {
		// don't use "call" because browser support for it
        // is inconsistent.
        if (window[event].constructor == Function) {
            window[event](eventArgs);
        } 
    }
}


function songPaused(/*Array*/ args) {
    document.title = "(Paused) " + args[0] + "  by  " + args[1] + " - " + "PandoraFM";
}

function songEnded(/*Array*/ args) {
    document.title = originalTitle;
}
function openWindow(/*Array*/ args) {
    window.open(args[0], args[1]);
}

function openMyFavoritesWindow(/*Array*/ args) {
    window.open(args[0] + "&itunes=" + itunesAffiliateUrl + "&amazon=" + amazonAffiliateUrl, args[1]);
}

function myFavoriteWebPageUrlChanged(/*Array*/ args) {
    document.myfavorite_url = args[0];
    gDisplayFavoriteLink = document.myfavorite_url != null && document.myfavorite_url != "" && document.myfavorite_url != "null";
    updateFavoriteLinkDisplay();
}

function updateFavoriteLinkDisplay() {
}

function InitializeTimer(timeOut, funcName) {
    functionName = funcName;
    secs = timeOut;
    stopTheClock();
    startTheTimer();
}

function stopTheClock() {
    if (timerRunning) {
        clearTimeout(timerID);
    }
    timerRunning = false;
}

function abort() {
    stopTheClock();
    $('countDown').value = functionName + " aborted.";
}

function startTheTimer() {
    if (secs == 0) {
        $('countDown').value = functionName + " complete.";
        stopTheClock();
        eval(functionName);
    }
    else {
        $('countDown').value = "Executing " + functionName + " in " + secs + " seconds";
        window.status = secs;
        secs = secs - 1;
        timerRunning = true;
        timerID = self.setTimeout("startTheTimer()", delay);
    }
}

	
	