/**
 * Created by IntelliJ IDEA.
 * User: irieb
 * Date: May 24, 2006
 * Time: 5:40:52 PM
 * To change this template use File | Settings | File Templates.
 */
package properties;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

public class DefaultProperties {
    private static Log LOG = LogFactory.getLog(DefaultProperties.class);
    public static final String MP3_ARCHIVE_PATH = "mp3.archive.path";

    public static String getMp3ArchivePath() {
        Properties properties = new Properties();
        try {
            properties.load(new FileInputStream("default.properties"));
            return properties.getProperty(MP3_ARCHIVE_PATH);
        } catch (IOException e) {
            LOG.warn("Unable to load archive path property. using default");
        }
        return null;
    }
}
