package server;

import java.util.Map;
import java.util.HashMap;

public class Session {
    private Map<String,Object> attributes;
    private String sessionId;

    public Session(String sessionId) {
        this.sessionId = sessionId;
        this.attributes = new HashMap<String, Object>();
    }

    public void setAttribute(String attributeName, Object attributeValue) {
        attributes.put(attributeName, attributeValue);
    }

    public Object getAttribute(String attributeName) {
        return attributes.get(attributeName);
    }

    public String getSessionId() {
        return sessionId;
    }

}
